(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory() :
  typeof define === 'function' && define.amd ? define(factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, global.ContentfulRichText = factory());
})(this, (function () { 'use strict';

  function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);

    if (Object.getOwnPropertySymbols) {
      var symbols = Object.getOwnPropertySymbols(object);
      enumerableOnly && (symbols = symbols.filter(function (sym) {
        return Object.getOwnPropertyDescriptor(object, sym).enumerable;
      })), keys.push.apply(keys, symbols);
    }

    return keys;
  }

  function _objectSpread2(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = null != arguments[i] ? arguments[i] : {};
      i % 2 ? ownKeys(Object(source), !0).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }

    return target;
  }

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  }

  function _toConsumableArray(arr) {
    return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
  }

  function _arrayWithoutHoles(arr) {
    if (Array.isArray(arr)) return _arrayLikeToArray(arr);
  }

  function _iterableToArray(iter) {
    if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
  }

  function _unsupportedIterableToArray(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _arrayLikeToArray(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(o);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
  }

  function _arrayLikeToArray(arr, len) {
    if (len == null || len > arr.length) len = arr.length;

    for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

    return arr2;
  }

  function _nonIterableSpread() {
    throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }

  var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

  var dist = {};

  var blocks = {};

  (function (exports) {
  	Object.defineProperty(exports, "__esModule", { value: true });
  	exports.BLOCKS = void 0;
  	(function (BLOCKS) {
  	    BLOCKS["DOCUMENT"] = "document";
  	    BLOCKS["PARAGRAPH"] = "paragraph";
  	    BLOCKS["HEADING_1"] = "heading-1";
  	    BLOCKS["HEADING_2"] = "heading-2";
  	    BLOCKS["HEADING_3"] = "heading-3";
  	    BLOCKS["HEADING_4"] = "heading-4";
  	    BLOCKS["HEADING_5"] = "heading-5";
  	    BLOCKS["HEADING_6"] = "heading-6";
  	    BLOCKS["OL_LIST"] = "ordered-list";
  	    BLOCKS["UL_LIST"] = "unordered-list";
  	    BLOCKS["LIST_ITEM"] = "list-item";
  	    BLOCKS["HR"] = "hr";
  	    BLOCKS["QUOTE"] = "blockquote";
  	    BLOCKS["EMBEDDED_ENTRY"] = "embedded-entry-block";
  	    BLOCKS["EMBEDDED_ASSET"] = "embedded-asset-block";
  	    BLOCKS["TABLE"] = "table";
  	    BLOCKS["TABLE_ROW"] = "table-row";
  	    BLOCKS["TABLE_CELL"] = "table-cell";
  	    BLOCKS["TABLE_HEADER_CELL"] = "table-header-cell";
  	})(exports.BLOCKS || (exports.BLOCKS = {}));
  	
  } (blocks));

  var inlines = {};

  (function (exports) {
  	Object.defineProperty(exports, "__esModule", { value: true });
  	exports.INLINES = void 0;
  	(function (INLINES) {
  	    INLINES["HYPERLINK"] = "hyperlink";
  	    INLINES["ENTRY_HYPERLINK"] = "entry-hyperlink";
  	    INLINES["ASSET_HYPERLINK"] = "asset-hyperlink";
  	    INLINES["EMBEDDED_ENTRY"] = "embedded-entry-inline";
  	})(exports.INLINES || (exports.INLINES = {}));
  	
  } (inlines));

  var marks = {};

  Object.defineProperty(marks, "__esModule", { value: true });
  /**
   * Map of all Contentful marks.
   */
  var MARKS;
  (function (MARKS) {
      MARKS["BOLD"] = "bold";
      MARKS["ITALIC"] = "italic";
      MARKS["UNDERLINE"] = "underline";
      MARKS["CODE"] = "code";
      MARKS["SUPERSCRIPT"] = "superscript";
      MARKS["SUBSCRIPT"] = "subscript";
  })(MARKS || (MARKS = {}));
  marks.default = MARKS;

  var schemaConstraints = {};

  (function (exports) {
  	var __spreadArray = (commonjsGlobal && commonjsGlobal.__spreadArray) || function (to, from, pack) {
  	    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
  	        if (ar || !(i in from)) {
  	            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
  	            ar[i] = from[i];
  	        }
  	    }
  	    return to.concat(ar || Array.prototype.slice.call(from));
  	};
  	var __importDefault = (commonjsGlobal && commonjsGlobal.__importDefault) || function (mod) {
  	    return (mod && mod.__esModule) ? mod : { "default": mod };
  	};
  	var _a;
  	Object.defineProperty(exports, "__esModule", { value: true });
  	exports.V1_MARKS = exports.V1_NODE_TYPES = exports.TEXT_CONTAINERS = exports.HEADINGS = exports.CONTAINERS = exports.VOID_BLOCKS = exports.TABLE_BLOCKS = exports.LIST_ITEM_BLOCKS = exports.TOP_LEVEL_BLOCKS = void 0;
  	var blocks_1 = blocks;
  	var inlines_1 = inlines;
  	var marks_1 = __importDefault(marks);
  	/**
  	 * Array of all top level block types.
  	 * Only these block types can be the direct children of the document.
  	 */
  	exports.TOP_LEVEL_BLOCKS = [
  	    blocks_1.BLOCKS.PARAGRAPH,
  	    blocks_1.BLOCKS.HEADING_1,
  	    blocks_1.BLOCKS.HEADING_2,
  	    blocks_1.BLOCKS.HEADING_3,
  	    blocks_1.BLOCKS.HEADING_4,
  	    blocks_1.BLOCKS.HEADING_5,
  	    blocks_1.BLOCKS.HEADING_6,
  	    blocks_1.BLOCKS.OL_LIST,
  	    blocks_1.BLOCKS.UL_LIST,
  	    blocks_1.BLOCKS.HR,
  	    blocks_1.BLOCKS.QUOTE,
  	    blocks_1.BLOCKS.EMBEDDED_ENTRY,
  	    blocks_1.BLOCKS.EMBEDDED_ASSET,
  	    blocks_1.BLOCKS.TABLE,
  	];
  	/**
  	 * Array of all allowed block types inside list items
  	 */
  	exports.LIST_ITEM_BLOCKS = [
  	    blocks_1.BLOCKS.PARAGRAPH,
  	    blocks_1.BLOCKS.HEADING_1,
  	    blocks_1.BLOCKS.HEADING_2,
  	    blocks_1.BLOCKS.HEADING_3,
  	    blocks_1.BLOCKS.HEADING_4,
  	    blocks_1.BLOCKS.HEADING_5,
  	    blocks_1.BLOCKS.HEADING_6,
  	    blocks_1.BLOCKS.OL_LIST,
  	    blocks_1.BLOCKS.UL_LIST,
  	    blocks_1.BLOCKS.HR,
  	    blocks_1.BLOCKS.QUOTE,
  	    blocks_1.BLOCKS.EMBEDDED_ENTRY,
  	    blocks_1.BLOCKS.EMBEDDED_ASSET,
  	];
  	exports.TABLE_BLOCKS = [
  	    blocks_1.BLOCKS.TABLE,
  	    blocks_1.BLOCKS.TABLE_ROW,
  	    blocks_1.BLOCKS.TABLE_CELL,
  	    blocks_1.BLOCKS.TABLE_HEADER_CELL,
  	];
  	/**
  	 * Array of all void block types
  	 */
  	exports.VOID_BLOCKS = [blocks_1.BLOCKS.HR, blocks_1.BLOCKS.EMBEDDED_ENTRY, blocks_1.BLOCKS.EMBEDDED_ASSET];
  	/**
  	 * Dictionary of all container block types, and the set block types they accept as children.
  	 *
  	 * Note: This does not include `[BLOCKS.DOCUMENT]: TOP_LEVEL_BLOCKS`
  	 */
  	exports.CONTAINERS = (_a = {},
  	    _a[blocks_1.BLOCKS.OL_LIST] = [blocks_1.BLOCKS.LIST_ITEM],
  	    _a[blocks_1.BLOCKS.UL_LIST] = [blocks_1.BLOCKS.LIST_ITEM],
  	    _a[blocks_1.BLOCKS.LIST_ITEM] = exports.LIST_ITEM_BLOCKS,
  	    _a[blocks_1.BLOCKS.QUOTE] = [blocks_1.BLOCKS.PARAGRAPH],
  	    _a[blocks_1.BLOCKS.TABLE] = [blocks_1.BLOCKS.TABLE_ROW],
  	    _a[blocks_1.BLOCKS.TABLE_ROW] = [blocks_1.BLOCKS.TABLE_CELL, blocks_1.BLOCKS.TABLE_HEADER_CELL],
  	    _a[blocks_1.BLOCKS.TABLE_CELL] = [blocks_1.BLOCKS.PARAGRAPH],
  	    _a[blocks_1.BLOCKS.TABLE_HEADER_CELL] = [blocks_1.BLOCKS.PARAGRAPH],
  	    _a);
  	/**
  	 * Array of all heading levels
  	 */
  	exports.HEADINGS = [
  	    blocks_1.BLOCKS.HEADING_1,
  	    blocks_1.BLOCKS.HEADING_2,
  	    blocks_1.BLOCKS.HEADING_3,
  	    blocks_1.BLOCKS.HEADING_4,
  	    blocks_1.BLOCKS.HEADING_5,
  	    blocks_1.BLOCKS.HEADING_6,
  	];
  	/**
  	 * Array of all block types that may contain text and inline nodes.
  	 */
  	exports.TEXT_CONTAINERS = __spreadArray([blocks_1.BLOCKS.PARAGRAPH], exports.HEADINGS, true);
  	/**
  	 * Node types before `tables` release.
  	 */
  	exports.V1_NODE_TYPES = [
  	    blocks_1.BLOCKS.DOCUMENT,
  	    blocks_1.BLOCKS.PARAGRAPH,
  	    blocks_1.BLOCKS.HEADING_1,
  	    blocks_1.BLOCKS.HEADING_2,
  	    blocks_1.BLOCKS.HEADING_3,
  	    blocks_1.BLOCKS.HEADING_4,
  	    blocks_1.BLOCKS.HEADING_5,
  	    blocks_1.BLOCKS.HEADING_6,
  	    blocks_1.BLOCKS.OL_LIST,
  	    blocks_1.BLOCKS.UL_LIST,
  	    blocks_1.BLOCKS.LIST_ITEM,
  	    blocks_1.BLOCKS.HR,
  	    blocks_1.BLOCKS.QUOTE,
  	    blocks_1.BLOCKS.EMBEDDED_ENTRY,
  	    blocks_1.BLOCKS.EMBEDDED_ASSET,
  	    inlines_1.INLINES.HYPERLINK,
  	    inlines_1.INLINES.ENTRY_HYPERLINK,
  	    inlines_1.INLINES.ASSET_HYPERLINK,
  	    inlines_1.INLINES.EMBEDDED_ENTRY,
  	    'text',
  	];
  	/**
  	 * Marks before `superscript` & `subscript` release.
  	 */
  	exports.V1_MARKS = [marks_1.default.BOLD, marks_1.default.CODE, marks_1.default.ITALIC, marks_1.default.UNDERLINE];
  	
  } (schemaConstraints));

  var types = {};

  Object.defineProperty(types, "__esModule", { value: true });

  var nodeTypes = {};

  Object.defineProperty(nodeTypes, "__esModule", { value: true });

  var emptyDocument = {};

  Object.defineProperty(emptyDocument, "__esModule", { value: true });
  var blocks_1$1 = blocks;
  /**
   * A rich text document considered to be empty.
   * Any other document structure than this is not considered empty.
   */
  var EMPTY_DOCUMENT = {
      nodeType: blocks_1$1.BLOCKS.DOCUMENT,
      data: {},
      content: [
          {
              nodeType: blocks_1$1.BLOCKS.PARAGRAPH,
              data: {},
              content: [
                  {
                      nodeType: 'text',
                      value: '',
                      marks: [],
                      data: {},
                  },
              ],
          },
      ],
  };
  emptyDocument.default = EMPTY_DOCUMENT;

  var helpers = {};

  Object.defineProperty(helpers, "__esModule", { value: true });
  helpers.isText = helpers.isBlock = helpers.isInline = void 0;
  var blocks_1 = blocks;
  var inlines_1 = inlines;
  /**
   * Tiny replacement for Object.values(object).includes(key) to
   * avoid including CoreJS polyfills
   */
  function hasValue(obj, value) {
      for (var _i = 0, _a = Object.keys(obj); _i < _a.length; _i++) {
          var key = _a[_i];
          if (value === obj[key]) {
              return true;
          }
      }
      return false;
  }
  /**
   * Checks if the node is an instance of Inline.
   */
  function isInline(node) {
      return hasValue(inlines_1.INLINES, node.nodeType);
  }
  helpers.isInline = isInline;
  /**
   * Checks if the node is an instance of Block.
   */
  function isBlock(node) {
      return hasValue(blocks_1.BLOCKS, node.nodeType);
  }
  helpers.isBlock = isBlock;
  /**
   * Checks if the node is an instance of Text.
   */
  function isText(node) {
      return node.nodeType === 'text';
  }
  helpers.isText = isText;

  (function (exports) {
  	var __createBinding = (commonjsGlobal && commonjsGlobal.__createBinding) || (Object.create ? (function(o, m, k, k2) {
  	    if (k2 === undefined) k2 = k;
  	    var desc = Object.getOwnPropertyDescriptor(m, k);
  	    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
  	      desc = { enumerable: true, get: function() { return m[k]; } };
  	    }
  	    Object.defineProperty(o, k2, desc);
  	}) : (function(o, m, k, k2) {
  	    if (k2 === undefined) k2 = k;
  	    o[k2] = m[k];
  	}));
  	var __setModuleDefault = (commonjsGlobal && commonjsGlobal.__setModuleDefault) || (Object.create ? (function(o, v) {
  	    Object.defineProperty(o, "default", { enumerable: true, value: v });
  	}) : function(o, v) {
  	    o["default"] = v;
  	});
  	var __exportStar = (commonjsGlobal && commonjsGlobal.__exportStar) || function(m, exports) {
  	    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
  	};
  	var __importStar = (commonjsGlobal && commonjsGlobal.__importStar) || function (mod) {
  	    if (mod && mod.__esModule) return mod;
  	    var result = {};
  	    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
  	    __setModuleDefault(result, mod);
  	    return result;
  	};
  	var __importDefault = (commonjsGlobal && commonjsGlobal.__importDefault) || function (mod) {
  	    return (mod && mod.__esModule) ? mod : { "default": mod };
  	};
  	Object.defineProperty(exports, "__esModule", { value: true });
  	exports.helpers = exports.EMPTY_DOCUMENT = exports.MARKS = exports.INLINES = exports.BLOCKS = void 0;
  	var blocks_1 = blocks;
  	Object.defineProperty(exports, "BLOCKS", { enumerable: true, get: function () { return blocks_1.BLOCKS; } });
  	var inlines_1 = inlines;
  	Object.defineProperty(exports, "INLINES", { enumerable: true, get: function () { return inlines_1.INLINES; } });
  	var marks_1 = marks;
  	Object.defineProperty(exports, "MARKS", { enumerable: true, get: function () { return __importDefault(marks_1).default; } });
  	__exportStar(schemaConstraints, exports);
  	__exportStar(types, exports);
  	__exportStar(nodeTypes, exports);
  	var emptyDocument_1 = emptyDocument;
  	Object.defineProperty(exports, "EMPTY_DOCUMENT", { enumerable: true, get: function () { return __importDefault(emptyDocument_1).default; } });
  	var helpers$1 = __importStar(helpers);
  	exports.helpers = helpers$1;
  	
  } (dist));

  var h = globalThis.Vue.h;

  var _defaultMarkRenderers, _defaultNodeRenderers;

  var defaultInline = function defaultInline(type, node, key) {
    return h("span", {
      key: key,
      style: {
        margin: "0px 5px",
        padding: "0 .25rem 0 .75rem",
        border: "1px solid #d3dce0",
        fontFamily: "monospace"
      }
    }, "inline: ".concat(type, ", sys.id: ").concat(node.data.target.sys.id));
  };

  var defaultMarkRenderers = (_defaultMarkRenderers = {}, _defineProperty(_defaultMarkRenderers, dist.MARKS.BOLD, function (children, key) {
    return h("strong", {
      key: key
    }, children);
  }), _defineProperty(_defaultMarkRenderers, dist.MARKS.ITALIC, function (children, key) {
    return h("em", {
      key: key
    }, children);
  }), _defineProperty(_defaultMarkRenderers, dist.MARKS.UNDERLINE, function (children, key) {
    return h("u", {
      key: key
    }, children);
  }), _defineProperty(_defaultMarkRenderers, dist.MARKS.CODE, function (children, key) {
    return h("code", {
      key: key
    }, children);
  }), _defineProperty(_defaultMarkRenderers, dist.MARKS.SUPERSCRIPT, function (children, key) {
    return h("sup", {
      key: key
    }, children);
  }), _defineProperty(_defaultMarkRenderers, dist.MARKS.SUBSCRIPT, function (children, key) {
    return h("sub", {
      key: key
    }, children);
  }), _defaultMarkRenderers);
  var defaultNodeRenderers = (_defaultNodeRenderers = {}, _defineProperty(_defaultNodeRenderers, dist.BLOCKS.PARAGRAPH, function (node, key, next) {
    return h("p", {
      key: key
    }, next(node.content, key, next));
  }), _defineProperty(_defaultNodeRenderers, dist.BLOCKS.HEADING_1, function (node, key, next) {
    return h("h1", {
      key: key
    }, next(node.content, key, next));
  }), _defineProperty(_defaultNodeRenderers, dist.BLOCKS.HEADING_2, function (node, key, next) {
    return h("h2", {
      key: key
    }, next(node.content, key, next));
  }), _defineProperty(_defaultNodeRenderers, dist.BLOCKS.HEADING_3, function (node, key, next) {
    return h("h3", {
      key: key
    }, next(node.content, key, next));
  }), _defineProperty(_defaultNodeRenderers, dist.BLOCKS.HEADING_4, function (node, key, next) {
    return h("h4", {
      key: key
    }, next(node.content, key, next));
  }), _defineProperty(_defaultNodeRenderers, dist.BLOCKS.HEADING_5, function (node, key, next) {
    return h("h5", {
      key: key
    }, next(node.content, key, next));
  }), _defineProperty(_defaultNodeRenderers, dist.BLOCKS.HEADING_6, function (node, key, next) {
    return h("h6", {
      key: key
    }, next(node.content, key, next));
  }), _defineProperty(_defaultNodeRenderers, dist.BLOCKS.EMBEDDED_ENTRY, function (node, key, next) {
    return h("div", {
      key: key
    }, next(node.content, key, next));
  }), _defineProperty(_defaultNodeRenderers, dist.BLOCKS.UL_LIST, function (node, key, next) {
    return h("ul", {
      key: key
    }, next(node.content, key, next));
  }), _defineProperty(_defaultNodeRenderers, dist.BLOCKS.OL_LIST, function (node, key, next) {
    return h("ol", {
      key: key
    }, next(node.content, key, next));
  }), _defineProperty(_defaultNodeRenderers, dist.BLOCKS.LIST_ITEM, function (node, key, next) {
    return h("li", {
      key: key
    }, next(node.content, key, next));
  }), _defineProperty(_defaultNodeRenderers, dist.BLOCKS.QUOTE, function (node, key, next) {
    return h("blockquote", {
      key: key
    }, next(node.content, key, next));
  }), _defineProperty(_defaultNodeRenderers, dist.BLOCKS.TABLE, function (node, key, next) {
    return h("table", {
      key: key
    }, next(node.content, key, next));
  }), _defineProperty(_defaultNodeRenderers, dist.BLOCKS.TABLE_ROW, function (node, key, next) {
    return h("tr", {
      key: key
    }, next(node.content, key, next));
  }), _defineProperty(_defaultNodeRenderers, dist.BLOCKS.TABLE_CELL, function (node, key, next) {
    return h("td", {
      key: key
    }, next(node.content, key, next));
  }), _defineProperty(_defaultNodeRenderers, dist.BLOCKS.TABLE_HEADER_CELL, function (node, key, next) {
    return h("th", {
      key: key
    }, next(node.content, key, next));
  }), _defineProperty(_defaultNodeRenderers, dist.BLOCKS.HR, function (_node, key) {
    return h("hr", {
      key: key
    });
  }), _defineProperty(_defaultNodeRenderers, dist.INLINES.ASSET_HYPERLINK, function (node, key) {
    return defaultInline(dist.INLINES.ASSET_HYPERLINK, node, key);
  }), _defineProperty(_defaultNodeRenderers, dist.INLINES.ENTRY_HYPERLINK, function (node, key) {
    return defaultInline(dist.INLINES.ENTRY_HYPERLINK, node, key);
  }), _defineProperty(_defaultNodeRenderers, dist.INLINES.EMBEDDED_ENTRY, function (node, key) {
    return defaultInline(dist.INLINES.EMBEDDED_ENTRY, node, key);
  }), _defineProperty(_defaultNodeRenderers, dist.INLINES.HYPERLINK, function (node, key, next) {
    return h("a", {
      key: key,
      href: node.data.uri
    }, next(node.content, key, next));
  }), _defineProperty(_defaultNodeRenderers, "text", function text(_ref, key, markRenderer) {
    var marks = _ref.marks,
        value = _ref.value;

    if (!marks.length) {
      return value;
    }

    var marksReversed = _toConsumableArray(marks).reverse();

    return marksReversed.reduce(function (aggregate, mark, i) {
      return markRenderer[mark.type]([aggregate], "".concat(key, "-").concat(i), h);
    }, value);
  }), _defaultNodeRenderers);

  var renderNodeList = function renderNodeList(nodes, key, renderer) {
    return nodes.map(function (node, i) {
      return renderNode(node, "".concat(key, "-").concat(i), renderer);
    });
  };

  var renderNode = function renderNode(node, key, renderer) {
    var nodeRenderer = renderer.node;

    if (dist.helpers.isText(node)) {
      // We're at final tip of node branch, can render text.
      var markerRender = renderer.mark;
      return nodeRenderer.text(node, key, markerRender);
    } else {
      var nextNode = function nextNode(nodes) {
        return renderNodeList(nodes, key, renderer);
      };

      if (!nodeRenderer) {
        return h("div", {
          key: key
        }, "".concat(key, " ;lost nodeRenderer"));
      }

      if (!node.nodeType || !nodeRenderer[node.nodeType]) {
        // TODO: Figure what to return when passed an unrecognized node.
        return h("div", {
          key: key
        }, "(Unrecognized node type) " + (node.nodeType || "empty"));
      }

      return nodeRenderer[node.nodeType](node, key, nextNode);
    }
  };

  var RichText = function RichText(_ref2) {
    var nodeRenderers = _ref2.nodeRenderers,
        markRenderers = _ref2.markRenderers,
        document = _ref2.document;

    if (!document) {
      console.warn("No document given to RichText renderer");
      return [];
    }

    var renderer = {
      node: _objectSpread2(_objectSpread2({}, defaultNodeRenderers), nodeRenderers),
      mark: _objectSpread2(_objectSpread2({}, defaultMarkRenderers), markRenderers)
    };
    return renderNodeList(document.content, "RichText-", renderer);
  };

  RichText.props = ["document", "nodeRenderers", "markRenderers"];

  return RichText;

}));
